package
{
	import __AS3__.vec.Vector;
	
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	
	public class Sphere extends Geometry
	{
		public function Sphere(detail:int)
		{
			super();
			buildSphere(detail);
		}
		
		private function buildSphere(detail:int):void
		{
			vertices = new Vector.<Number>();
			for(var v:int = 0; v < detail; v++)
			{
				for(var u:int = 0; u < detail; u++)
				{
					var alpha:Number = -2.0*Math.PI*(u/(detail-1.0));
					var theta:Number =  2.0*Math.PI*(v/(detail-1.0));
					
					var sin_a:Number = Math.sin(alpha);
					var cos_a:Number = Math.cos(alpha);
					var sin_t:Number = Math.sin(theta);
					var cos_t:Number = Math.cos(theta);
					
					vertices.push(sin_t*sin_a);
					vertices.push(cos_t);
					vertices.push(sin_t*cos_a);
				}
			}
			normals = vertices; // 球の中心を原点とするので法線ベクトルと頂点座標の値は同じ
			
			indices = new Vector.<int>();
			for(v = 0; v < detail-1; v++)
			{
				for(u = 0; u < detail-1; u++)
				{
					indices.push(v*detail + u);
					indices.push(v*detail + u + 1);
					indices.push((v+1)*detail + u);
					
					indices.push((v+1)*detail + u);
					indices.push(v*detail + u + 1);
					indices.push((v+1)*detail + u + 1);
				}
			}
			projected_vertices = new Vector.<Number>(detail*detail*2);
		}
		
		public function calcUV(mat:Matrix3D):void
		{
			uvts = new Vector.<Number>();
			for(var index:int = 0; index < vertices.length; index+=3)
			{
				var vertex:Vector3D = new Vector3D(vertices[index], vertices[index+1], vertices[index+2]);
				vertex = mat.transformVector(vertex);
				vertex.normalize(); // -1 〜 1 の範囲に

				uvts.push((vertex.x + 1.0) / 2.0);
				uvts.push((vertex.y + 1.0) / 2.0);
				uvts.push(1.0); // t は仮の値を入れる
			}
		}
	}
}